'REMBOSAFE
'AMANZI Nunzio - LNF Computing Services - April 2004

Option Explicit

'Const vbSunday = 1  
'Const vbMonday = 2  
'Const vbTuesday = 3 
'Const vbWednesday = 4  
'Const vbThursday = 5  
'Const vbFriday = 6 
'Const vbSaturday = 7 

Const TsmDay = 7							'WeekDay for TSM Backup


Const OnRemote = true							'used to make code best readable
Const OnLocal = false							'used to make code best readable
Const goStart = true							'used to make code best readable
Const goStop = false							'used to make code best readable

Const servicename = "RemboServer"
Const RemoteHostName = "pcrembo1"					'name of remote rembo host 
Const SourceCopyFolder = "e$\rembo\files"				'rembo root repository path on remote: use drive$\folder-list
Const TargetCopyFolder = "e:\rembo\files"				'rembo root repository path on local:  use drive:\folder-list
COnst TsmLogPathTemplate = "c:\winnt\adminscripts\logs\tsm_"		'local log path used to generate a log file instance



Const SyncLogFullName = "C:\winnt\adminscripts\Logs\rembosync.log"
Const BkSyncLogFullName = "C:\winnt\adminscripts\Logs\rembosync_old.log"
Const SyncLogSizeLimit = 20000000     					'Over that size (bytes) logfile will be backuped ad then deleted

Dim objLocator	      'to access to a wmi namespace
Dim objService        'obtain a wmi local server handle
Dim RemoteobjService  'obtain a wmi remote server handl
Dim instances         'locate a wmi service instance
Dim WshShell	      'Shell Object to run tasks

Dim LogStr	      'Used in logs writing
Dim EvalCode


Sub WriteLog(severity, comment)
On error resume next
   WshShell.LogEvent severity, comment
End Sub

Function InitLocator() 
'must be called at init main body
On error resume next
Dim result
    
   result = true 
   'building a locator tool object...
   Set objLocator = CreateObject("WbemScripting.SWbemLocator")
   if Err.Number > 0 then
      result = false
      Err.Clear
   End if

   InitLocator = result
End Function

Sub DoneLocator()
'must be called at the end of main body
on error resume next
   Set objLocator = Nothing
End Sub

Function WmiLogin(IsRemote)
'logon localhost
'if bithservers is true then logon remoteserver too
On error resume next
Dim result
    
   result = true 
   
      'obtain a  wmi server instance
      if not IsRemote then
         Set objService = objLocator.ConnectServer(".", "root\cimv2", "", "")   'connect to localhost with actual credentials
      Else
         Set RemoteobjService = objLocator.ConnectServer(RemoteHostName, "root\cimv2", "", "")   'logon remote too
      End if

      if Err.Number > 0 then
         result = false
         Err.Clear
      Else
         if not IsRemote then 
            objService.Security_.ImpersonationLevel = 3  'using personal authentication level
         else
            RemoteobjService.Security_.ImpersonationLevel = 3
         end if
         if Err.Number > 0 then
            result = false
            Set objService = Nothing
            Set RemoteobjService = Nothing
         End if
      End if
    

   WmiLogin = result
End Function


Sub CommentLogFile(isbegin)
'write starting/ending rows to log file
On error resume next
Dim fso
Dim f
Dim Commentstr

   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.OpenTextFile(SyncLogFullName, 8)           'append mode
   if Err.Number > 0 then
      Err.Clear
   Else
      if isbegin then
         f.WriteLine "Starting new rembo sync process at " & Now()
      Else
         f.WriteLine "Process terminated at " & Now()
         f.WriteLine "---------"
         F.WriteLine " " 
      End if
      f.Close
      set f = Nothing
      set fso = Nothing
   End If
End Sub


Function LogFileBackupped()
'check size of log file and backuped it if necessary
'return value -1:error, 0:ok without backup, 1:ok with backup
On error resume next
Dim result
Dim fso
Dim f
Dim backupped

   result = true
   backupped = false   
   Set fso = CreateObject("Scripting.FileSystemObject")
   if not fso.FileExists(SyncLogFullName) then fso.CreateTextFile SyncLogFullName, true
      Set f = fso.GetFile(SyncLogFullName)
   if Err.Number > 0 then
      result = false
      Err.Clear
   Else
      if f.size > SyncLogSizeLimit then 
      'make a backup copy
          f.copy BkSyncLogFullName, true
          fso.CreateTextFile SyncLogFullName, true   'overwrite original log file
          if Err.Number > 0 then
              result = false
              Err.clear
          Else
              backupped = true
           End if
       end if
   End if 
   
   
   Set f = Nothing
   Set fso = Nothing

   if result then 
      if backupped then LogFileBackupped = 1 else LogFileBackupped = 0
   else
      LogFileBackupped = -1
   end if
End Function


Function WmiLogout(IsRemote)
On error resume next

   'destroy objects ad tokens
   if not IsRemote then
      Set objService = Nothing
   else
      Set RemoteobjService = Nothing
   end if   
   
   Set instances = Nothing
   'Set WshShell = Nothing
End Function


Function DoService(mode, IsRemote)
On error resume next

Dim aservice
Dim result

   result = true
   
   if not IsRemote then
      set instances = objService.ExecQuery("Select * From Win32_Service Where Name = '" & servicename & "'")  'set of services (1 member only)
   Else
      set instances = RemoteobjService.ExecQuery("Select * From Win32_Service Where Name = '" & servicename & "'")
   End if

   if Err.Number > 0 then
      result = false
   Else
      'check on local
      if instances.count > 0 then
         For Each aservice in instances
            if not mode then 
               'stop
               aservice.StopService 
            else
               'start
                aservice.StartService
            end if
         Next  
         if Err.Number > 0 then
            result = false
            Err.Clear
         End if
      Else
         result = false   'no matching name service
      End if
   end if

   set instances = nothing
   set Remoteinstances = nothing
   DoService = result
End Function


Function BuildShell() 
On error resume next

Dim result

   result = true
   Set WshShell = WScript.CreateObject("WScript.Shell")

   if Err.Number > 0 then
      result = false
      Err.Clear
   End if

   BuildShell = result
End Function

Sub DoneShell()
   Set WshShell = Nothing
End Sub


Function TsmToDo()
'Decides if it is time to copy on TSM
On error resume next

Dim result

   result = false

   result = (Weekday(Now()) = TsmDay)

   TsmToDo = result
End Function


Function DoAction(cmd_name)
On error resume next

Dim result 
Dim returncode

    result = true
    if cmd_name <> "" then    
       returncode = WshShell.Run(cmd_name, 1, true)
       If (Err.Number > 0) then
          result = -1000
          Err.Clear
       Else 
          result = returncode
       End if
    Else
       result = -1000
    End if
    
    DoAction = result
End Function


'Command Subs performing sync actions

Sub SyncRemboFolders()
On error resume next
'perform copy from remote to localhost
'syncronize all global and shared rembo files

Dim XcopyCMDInstance 
Dim result
  
   XcopyCMDInstance = "CMD /C C:\winnt\adminscripts\Robocopy \\" & RemoteHostName & "\" & SourceCopyFolder & " " &  TargetCopyFolder & " /MIR /LOG+:" & SyncLogFullName

   LogStr = "Starting " & XcopyCMDInstance & " at " & Now() & " - "
   result = DoAction(XcopyCMDInstance)
   if result = -1000 then
      LogStr = LogStr & "Execution aborted at " & Now()
      WriteLog 1, LogStr
   Else
      LogStr = LogStr & "Process completed at " & Now() & " with code: " & result
      WriteLog 0, LogStr
   End if
End Sub

Sub SyncWinReg()
'get updated registry rembo keys
On error resume next
Const Key1 = "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\RemboServer\Parameters\Groups"
Const Key2 = "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\RemboServer\Parameters\Hosts" 
Dim RegCMDInstance
Dim result

   RegCMDInstance = "CMD /C C:\winnt\adminscripts\RegSync >> "  & SyncLogFullName & " " & Key1 & " " & RemoteHostName & " ."

   LogStr = "Starting " & RegCMDInstance & " at " & Now() & " - "
   result = DoAction(RegCMDInstance)
   if result = -1000 then
      LogStr = LogStr & "Execution aborted at " & Now()
      WriteLog 1, LogStr
   Else
      LogStr = LogStr & "Process completed at " & Now() & " with code: " & result
      WriteLog 0, LogStr
   End if

   RegCMDInstance = "CMD /C C:\winnt\adminscripts\RegSync >> "  & SyncLogFullName & " " & Key2 & " " & RemoteHostName & " ."

   LogStr = "Starting " & RegCMDInstance & " at " & Now() & " - "
   result = DoAction(RegCMDInstance)
   if result = -1000 then
      LogStr = LogStr & "Execution aborted at " & Now()
      WriteLog 1, LogStr
   Else
      LogStr = LogStr & "Process completed at " & Now() & " with code: " & result
      WriteLog 0, LogStr
   End if
End Sub

Sub SyncOnTsm()
On error resume next
'copy localhost rembo repository on backup tsm server
Dim TsmCMDInstance
Dim result

   TsmCMDInstance = "CMD /C dsmc incremental " & TargetCopyFolder & "\* -subdir=yes > " & TsmLogPathTemplate & year(Now()) & right("0" & month(Now()),2) & right("0" & day(Now()),2) & ".log"

   LogStr = "Starting " & TsmCMDInstance & " at " & Now() & " - "
   result = DoAction(TsmCMDInstance)
   if result = -1000 then
      LogStr = LogStr & "Execution aborted at " & Now()
      WriteLog 1, LogStr
   Else
      LogStr = LogStr & "Process completed at " & Now() & " with code: " & result
      WriteLog 0, LogStr
   End if   
End Sub


'------------------------
'main module

if BuildShell then
   if InitLocator() then
      'check over synclogfile
       EvalCode = Cint(LogFileBackupped())
       If EvalCode = 1 then
          WriteLog 0, "Rembo Sync Log file: " & SyncLogFullName & " backupped on " & BkSyncLogFullName & " at " & Now()
       else
          if EvalCode = -1 then WriteLog 1, "Error on Rembo Sync Log file accessing/checking"
       end if

       'To sync rembo folders Master & Slave have to go down
       If WmiLogin(OnLocal) then
          If WmiLogin(OnRemote) then
             if DoService(goStop, OnLocal) then
                if DoService(goStop, OnRemote) then
                   'both are down
                   SyncRemboFolders  		'sync rembo folders
                   
                   SyncWinReg   		'perform registry sync
                   
                   DoService goStart, OnRemote	'restart remote service
                Else
                   LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Cannot stop REMBO Service on remote server"
                   WriteLog 1, LogStr
                End if
                
                'tsm copy
                if TsmToDo() then
                   SyncOnTsm
                End if
                
                DoService goStart, OnLocal	'restore service locally
                WmiLogout(OnLocal)
                WmiLogout(OnRemote)
             Else
                LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Cannot stop REMBO Service on localhost"
                WriteLog 1, LogStr
                'logount servers
                WmiLogout(OnLocal)
                WmiLogout(OnRemote)
             End if
          Else
             LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Cannot perform a WMI Connection to remote server"
             WriteLog 1, LogStr
             'logout on local
             WmiLogout(OnLocal)
          End if
       Else
          LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Cannot perform a WMI Connection to localhost"
          WriteLog 1, LogStr
       End if
   DoneLocator
   Else
      LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Unable to initialize server locator object"
      WriteLog 1, LogStr
   End if
   DoneShell
Else
   LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Unable to initialize processes running object on localhost"
   WriteLog 1, LogStr
end if






