'REMBOSAFE
'AMANZI Nunzio - LNF Computing Services


'Const vbSunday = 1  
'Const vbMonday = 2  
'Const vbTuesday = 3 
'Const vbWednesday = 4  
'Const vbThursday = 5  
'Const vbFriday = 6 
'Const vbSaturday = 7 

Option Explicit

Const servicename = "RemboServer"
Const XcopyCMD = "CMD /C netclnt C:\winnt\adminscripts\rembosync.nc >> C:\winnt\adminscripts\logs\rembosync.log"
Const TsmCMD = "CMD /C dsmc incremental e:\rembo\* -subdir=yes "
Const TsmDay = 1
Const SyncLogFullName = "C:\winnt\adminscripts\Logs\rembosync.log"
Const BkSyncLogFullName = "C:\winnt\adminscripts\Logs\rembosync_old.log"
Const SyncLogSizeLimit = 1024000     'Over that size (bytes) logfile will be backuped ad then deleted

Dim objLocator	 'to access to a wmi namespace
Dim objService   'obtain a wmi server handle
Dim instances    'locate a wmi service instance
Dim WshShell	 'Shell Object to run tasks

Dim LogStr	 'Used in logs writing
Dim EvalCode
Dim TsmCMDInstance
TsmCMDInstance = TsmCMD & "> c:\winnt\adminscripts\logs\tsm_" & year(Now()) & right("0" & month(Now()),2) & right("0" & day(Now()),2) & ".log"


Sub WriteLog(severity, comment)
On error resume next
   WshShell.LogEvent severity, comment
End Sub

Function WmiLogin()
On error resume next
Dim result
   
   result = true 
   'building a locator tool object...
   Set objLocator = CreateObject("WbemScripting.SWbemLocator")
   if Err.Number > 0 then
      result = false
      Err.Clear
   Else
      'obtain a  wmi server instance
      Set objService = objLocator.ConnectServer(".", "root\cimv2", "", "")   'connect to localhost with actual credentials
      if Err.Number > 0 then
         result = false
         Err.Clear
         Set objLocator = Nothing
      Else
         objService.Security_.ImpersonationLevel = 3  'using personal authentication level
         if Err.Number > 0 then
            result = false
            Set objService = Nothing
            Set objLocator = Nothing
         End if
      End if
   End if 

   WmiLogin = result
End Function


Sub CommentLogFile(isbegin)
'write starting/ending rows to log file
On error resume next
Dim fso
Dim f
Dim Commentstr

   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.OpenTextFile(SyncLogFullName, 8)           'append mode
   if Err.Number > 0 then
      Err.Clear
   Else
      if isbegin then
         f.WriteLine "Starting new rembo sync process at " & Now()
      Else
         f.WriteLine "Process terminated at " & Now()
         f.WriteLine "---------"
         F.WriteLine " " 
      End if
      f.Close
      set f = Nothing
      set fso = Nothing
   End If
End Sub


Function LogFileBackupped()
'check size of log file and backuped it if necessary
'return value -1:error, 0:ok without backup, 1:ok with backup
On error resume next
Dim result
Dim fso
Dim f
Dim backupped

   result = true
   backupped = false   
   Set fso = CreateObject("Scripting.FileSystemObject")
   if not fso.FileExists(SyncLogFullName) then fso.CreateTextFile SyncLogFullName, true
      Set f = fso.GetFile(SyncLogFullName)
   if Err.Number > 0 then
      result = false
      Err.Clear
   Else
      if f.size > SyncLogSizeLimit then 
      'make a backup copy
          f.copy BkSyncLogFullName, true
          fso.CreateTextFile SyncLogFullName, true   'overwrite original log file
          if Err.Number > 0 then
              result = false
              Err.clear
          Else
              backupped = true
           End if
       end if
   End if 
   
   
   Set f = Nothing
   Set fso = Nothing

   if result then 
      if backupped then LogFileBackupped = 1 else LogFileBackupped = 0
   else
      LogFileBackupped = -1
   end if
End Function


Function WmiLogout()
On error resume next

   'destroy objects ad tokens
   Set instances = Nothing
   Set objService = Nothing
   Set objLocator = Nothing
   Set WshShell = Nothing

End Function


Function DoService(mode)
On error resume next

Dim aservice
Dim result

   result = true
   
   set instances = objService.ExecQuery("Select * From Win32_Service Where Name = '" & servicename & "'")  'set of services (1 member only)
   if Err.Number > 0 then
      result = false
   Else
      
      if instances.count > 0 then
         For Each aservice in instances
            if not mode then 
               'stop
               aservice.StopService 
            else
               'start
                aservice.StartService
            end if
         Next  
         if Err.Number > 0 then
            result = false
            Err.Clear
         End if
      Else
         result = false   'no matching name service
      End if
   end if

   set instances = nothing

   DoService = result
End Function


Function BuildShell() 
On error resume next

Dim result

   result = true
   Set WshShell = WScript.CreateObject("WScript.Shell")

   if Err.Number > 0 then
      result = false
      Err.Clear
   End if

   BuildShell = result
End Function



Function DoAction(cmd_name)
On error resume next

Dim result 
Dim returncode

    result = true
    if cmd_name <> "" then    
       returncode = WshShell.Run(cmd_name, 1, true)
       If (Err.Number > 0) or (returncode <> 0) then
          result = false
          Err.Clear
       End if
    Else
       result = false
    End if
    
    DoAction = result
End Function


'------------------------
'main module



if BuildShell then
   'check over synclogfile
   EvalCode = Cint(LogFileBackupped())
   If EvalCode = 1 then
      WriteLog 0, "Rembo Sync Log file: " & SyncLogFullName & " backupped on " & BkSyncLogFullName & " at " & Now()
   else
     if EvalCode = -1 then WriteLog 1, "Error on Rembo Sync Log file accessing/checking"
   end if

   'sync rembo folders
   CommentLogFile true
   LogStr = "Starting " & XcopyCMD & " at " & Now() & " - "
   if DoAction(XcopyCMD) then
      LogStr = LogStr & "Process completed with success at " & Now()
      WriteLog 0, LogStr
   Else
      LogStr = LogStr & "Process completed with error at " & Now()
      WriteLog 1, LogStr
   End if
   CommentLogFile false

   'if Weekday(Now()) = TsmDay then
   if true then
    'copy to tsm
      if WmiLogin then
         if DoService(false) then
         
             'exec tsm backup
             LogStr = "Starting " & TsmCMD & " at " & Now() & " - "
             if DoAction(TsmCMDInstance) then 
                LogStr = LogStr & "Process completed with success at " & Now()
                WriteLog 0, LogStr
             Else
                LogStr = LogStr & "Process completed with error at " & Now()
                WriteLog 1, LogStr
             End if
         
             DoService(true)
         Else
            LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Cannot stop REMBO Service on localhost"
            WriteLog 1, LogStr
         End if
      Else
         LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Cannot perform a WMI Connection to localhost"
         WriteLog 1, LogStr
      End if
      WmiLogout
   End if


Else
   LogStr = "REMBOSAFE - Script aborted at " & Now() & " - Unable to initialize processes running object on localhost"
   WriteLog 1, LogStr
end if






